"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const globals_1 = require("@jest/globals");
const bitUtils_1 = require("./bitUtils");
(0, globals_1.describe)('bitUtils 测试', () => {
    (0, globals_1.beforeAll)(() => {
        //instance = XRuleUtils.createRuleByValidId(EnumValidId.date);
    });
    (0, globals_1.test)('test isValidBitSite', () => {
        (0, globals_1.expect)(bitUtils_1.bitUtils.isValidBitSite(0)).toBe(true);
        (0, globals_1.expect)(bitUtils_1.bitUtils.isValidBitSite(-1)).toBe(false);
        (0, globals_1.expect)(bitUtils_1.bitUtils.isValidBitSite(31)).toBe(false);
        (0, globals_1.expect)(bitUtils_1.bitUtils.isValidBitSite(30)).toBe(true);
        (0, globals_1.expect)(bitUtils_1.bitUtils.isValidBitSite(0.1)).toBe(false);
        (0, globals_1.expect)(bitUtils_1.bitUtils.isValidBitSite(9.1)).toBe(false);
    });
    (0, globals_1.test)('test getFlag setFlag', () => {
        let v = 0;
        let j = 0;
        for (let i = bitUtils_1.EnumBitConst.MIN_BIT_SITE; i <= bitUtils_1.EnumBitConst.MAX_BIT_SITE; i++) {
            (0, globals_1.expect)(bitUtils_1.bitUtils.GetFlag(v, i)).toBe(0);
            v = bitUtils_1.bitUtils.SetFlag(v, i, 1);
            (0, globals_1.expect)(bitUtils_1.bitUtils.GetFlag(v, i)).toBe(1);
            j = j + 2 ** i;
            (0, globals_1.expect)(v).toBe(j);
        }
        (0, globals_1.expect)(v).toBe(0x7fffffff);
        for (let i = bitUtils_1.EnumBitConst.MIN_BIT_SITE; i <= bitUtils_1.EnumBitConst.MAX_BIT_SITE; i++) {
            (0, globals_1.expect)(bitUtils_1.bitUtils.GetFlag(v, i)).toBe(1);
            v = bitUtils_1.bitUtils.SetFlag(v, i, 0);
            (0, globals_1.expect)(bitUtils_1.bitUtils.GetFlag(v, i)).toBe(0);
            j = j - 2 ** i;
            (0, globals_1.expect)(v).toBe(j);
        }
        (0, globals_1.expect)(v).toBe(0);
    });
});
