/** 枚举的相关功能函数 */
export declare class EnumUtils {
    /**
     * 取枚举key列表
     * @param paramEnum 指定的枚举
     * @returns 枚举的key列表
     */
    static getEnumKeys(paramEnum: object): string[];
    /**
     * 取枚举值列表
     * @param paramEnum 指定的枚举
     * @returns 枚举的value列表
     */
    static getEnumValues<T = any>(paramEnum: object): T[];
    /**
     * 判断指定的值，是不是枚举中的值
     * @param paramValue 被检查的值
     * @param paramEnum 指定的枚举
     * @returns
     *  - true 表示是枚举的值
     *  - false 表示不是枚举的值
     */
    static valueInEnum<T = any>(paramValue: T, paramEnum: object): boolean;
    /**
     * 判断指定的key，是不是枚举中的key
     * @param paramKey 被检查的key
     * @param paramEnum 指定的枚举
     * @returns
     *  - true 表示是枚举的值
     *  - false 表示不是枚举的值
     */
    static keyInEnum(paramKey: string, paramEnum: object): boolean;
}
