"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const globals_1 = require("@jest/globals");
const utils_1 = __importDefault(require("./utils"));
(0, globals_1.describe)('utils 测试', () => {
    (0, globals_1.beforeAll)(() => {
        //
    });
    (0, globals_1.test)('测试isTrueEmpty', () => {
        (0, globals_1.expect)(utils_1.default.isTrueEmpty(0)).toBe(false);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty(null)).toBe(true);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty(undefined)).toBe(true);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty('')).toBe(true);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty(NaN)).toBe(true);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty('hello')).toBe(false);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty(-1)).toBe(false);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty(1)).toBe(false);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty(0.1)).toBe(false);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty(-0.1)).toBe(false);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty({})).toBe(false);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty([])).toBe(false);
        (0, globals_1.expect)(utils_1.default.isTrueEmpty(new Date())).toBe(false);
    });
    (0, globals_1.test)('测试isEmpty', () => {
        (0, globals_1.expect)(utils_1.default.isEmpty(0)).toBe(true);
        (0, globals_1.expect)(utils_1.default.isEmpty(null)).toBe(true);
        (0, globals_1.expect)(utils_1.default.isEmpty(undefined)).toBe(true);
        (0, globals_1.expect)(utils_1.default.isEmpty('')).toBe(true);
        (0, globals_1.expect)(utils_1.default.isEmpty(NaN)).toBe(true);
        (0, globals_1.expect)(utils_1.default.isEmpty('hello')).toBe(false);
        (0, globals_1.expect)(utils_1.default.isEmpty(-1)).toBe(false);
        (0, globals_1.expect)(utils_1.default.isEmpty(1)).toBe(false);
        (0, globals_1.expect)(utils_1.default.isEmpty(0.1)).toBe(false);
        (0, globals_1.expect)(utils_1.default.isEmpty(-0.1)).toBe(false);
        (0, globals_1.expect)(utils_1.default.isEmpty({})).toBe(true);
        (0, globals_1.expect)(utils_1.default.isEmpty({ a: 100 })).toBe(false);
        (0, globals_1.expect)(utils_1.default.isEmpty([])).toBe(true);
        (0, globals_1.expect)(utils_1.default.isEmpty(new Date())).toBe(false);
        (0, globals_1.expect)(utils_1.default.isEmpty(false)).toBe(true);
        (0, globals_1.expect)(utils_1.default.isEmpty(true)).toBe(false);
        (0, globals_1.expect)(utils_1.default.isEmpty(new Date('9999010101010'))).toBe(true);
        // null, undefined, '', {}, false, 无效日期, 0, [], NaN 这些都是空对象
    });
    (0, globals_1.test)('测试formatNumber', () => {
        // expect(utils.formatNumber(12345.999,'#,##0.00')).toBe('12,345.99');
        // expect(utils.formatNumber(12345.999,'#,##0.##')).toBe('12,345.99');
        // formatNumber(12345.999,'#,##0.00');
        // formatNumber(12345.999,'#,##0.##');
        // formatNumber(123,'000000');
    });
});
